import { createContext, useContext } from "react";
var MathboxAPIContext = createContext(null);
/**
 * Returns Mathbox API Selection object for the nearest enclosing Mathbox node.
 */
var useMathbox = function () {
    var selection = useContext(MathboxAPIContext);
    if (!selection) {
        throw new Error("useMathbox must be used within Mathbox or ContainedMathbox");
    }
    return selection;
};
export default MathboxAPIContext;
export { useMathbox };
//# sourceMappingURL=MathboxAPIContext.js.map