var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState } from "react";
import { CustomMathbox as Mathbox } from "./utils";
import { Cartesian, Grid, Point, Array as MBArray } from "../components";
export default {
    title: "Point",
    component: Point,
    argTypes: {
        color: {
            type: "string",
            defaultValue: "rgb(128, 128, 128)"
        },
        opacity: {
            type: "number",
            defaultValue: 1
        },
        points: {
            type: "array",
            defaultValue: [[1, 1, 1]]
        },
        size: {
            type: "number",
            defaultValue: 4
        }
    }
};
var Template = function (args) {
    var points = args.points, otherArgs = __rest(args, ["points"]);
    var _a = useState(null), data = _a[0], setData = _a[1];
    return (React.createElement(Mathbox, { containerStyle: { height: 450 } },
        React.createElement(Cartesian, { range: [
                [-5, 5],
                [-5, 5],
                [-5, 5],
            ] },
            React.createElement(Grid, { axes: "xy" }),
            React.createElement(Grid, { axes: "xz" }),
            React.createElement(MBArray, { ref: setData, items: 1, channels: 3, data: [
                    [1, 1, 2],
                    [1, 1, 3],
                ] }),
            React.createElement(MBArray, { items: 1, channels: 3, data: [
                    [1, 1, -2],
                    [1, 1, -3],
                ] }),
            React.createElement(Point, __assign({ points: data }, otherArgs)))));
};
export var DefaultPoint = Template.bind({});
DefaultPoint.args = {};
export var LiveProps = Template.bind({});
LiveProps.args = {
    liveProps: {
        size: function (t) { return 20 * (1 + 0.5 * Math.sin(t)); }
    }
};
//# sourceMappingURL=Point.stories.js.map